      module ffun_mod
      use ffun_data_mod
      implicit none
      
      contains
      
      integer function fadd(a,b)
         integer a,b,ios,i
         double precision :: x
         integer :: status
         allocate( test_mass_fractions(N_IONs), STAT=status )
         if (status /= 0) stop 'InsufficientMemory'
         test_mass_fractions(1:N_IONs) = 0d0
         deallocate( test_mass_fractions )
         write(*,*) 
         write(*,*) 'back from deallocate in fadd'
         fadd = a + b
         write(*,*) 
         write(*,*) 'fadd called with a=', a, ' and b=', b
         open(UNIT=10, FILE='data.txt', ACTION='read', IOSTAT=ios)
         if (ios /= 0) then
            write(*,*) 'cannot open data.txt'
         else
            read(10,*) i,x
            close(10)
            write(*,*) 'read from data.txt to get i', i, 'x', x
            write(*,*) 'use ffun_data_mod for ih1', ih1
         end if
         return
      end function fadd

      integer function funadd(fun,a,b)
         external fun
         integer a,b,fun
         funadd = fun(a,b)
         return
      end function funadd
   
      end module ffun_mod